UNIT EnumeratedTypes_MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, EnumeratedTypes_Basic;

CONST
  UnitID        = 1205;
  Version       = '1.00.00';
  VersionDate   = '2018-03-20';
  DevPlatform   = 'XE7';
  DbPlatform    = 'Not Applicable';
  Author        = 'P.K.Nauta';
  GUID          = '{79D4554E-3144-420B-959A-EC5E92F22E95}';

type
  TF_EnumeratedTypes_MainForm = class(TForm)
    Button1: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
      FStates     : TCrStateList;

  end;



var
  F_EnumeratedTypes_MainForm: TF_EnumeratedTypes_MainForm;

implementation

{$R *.dfm}

USES TypInfo, RTTI;

PROCEDURE TF_EnumeratedTypes_MainForm.Button1Click( Sender : TObject );

VAR
  lStates   : TCrStateList;

BEGIN
  lStates   := TCrStateList.Create;

  TRY
    lStates.PopulateStringList( ComboBox1.Items, 'Name' );
    lStates.NameCasing   := ncUpper;
    lStates.CompareField := 'Name';
    lStates.SortAscending  := False;
    lStates.Sort;
    lStates.PopulateOpenStates( ComboBox2.Items );
    ShowMessage( 'Done' );
  FINALLY
    lStates.Free;
  END;
END;

PROCEDURE TF_EnumeratedTypes_MainForm.ComboBox1DblClick(Sender: TObject);

VAR
  lStates : TCrStateList;
  sName   : String;

BEGIN
  lStates := TCrStateList.Create;

  TRY
    sName   := ComboBox1.Text;

    IF ( sName <> '' ) THEN
      ShowMessage( lStates.FindName( sName ).Description );
  FINALLY
    lStates.Free;
  END;
END;

end.
